import { CommonModule } from '@angular/common';
import { Component, Input, ElementRef, Output, EventEmitter, ViewChild, Renderer2, ViewEncapsulation, NgModule } from '@angular/core';
import { trigger, state, style, animate, transition } from '@angular/animations';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapSwitchComponent = /** @class */ (function () {
    function NgxBootstrapSwitchComponent(el, renderer) {
        this.el = el;
        this.renderer = renderer;
        // public properties
        this.status = false;
        this.statusChange = new EventEmitter();
        this.onText = 'On';
        this.offText = 'Off';
        this.onColor = 'bootstrap-switch-green';
        this.offColor = 'bootstrap-switch-red';
        this.size = 'normal';
        this.disabled = false;
        this._statusStr = 'false';
        // styles properties
        this._onColor = 'bootstrap-switch-green';
        this._offColor = 'bootstrap-switch-red';
        this._minWidth = 60;
        this._sizeClass = 'bootstrap-switch-normal';
        this._disabledClass = '';
        this._needCalculateWidth = false;
        this._calculateSize();
    }
    /**
     * @return {?}
     */
    NgxBootstrapSwitchComponent.prototype.toggleStatus = /**
     * @return {?}
     */
    function () {
        if (!this.disabled) {
            this.status = !this.status;
            this._statusStr = this.status.toString();
            this.statusChange.emit(this.status);
        }
    };
    /**
     * @private
     * @param {?} disabled
     * @return {?}
     */
    NgxBootstrapSwitchComponent.prototype._setDisabled = /**
     * @private
     * @param {?} disabled
     * @return {?}
     */
    function (disabled) {
        if (disabled) {
            this._disabledClass = 'bootstrap-switch-disabled';
        }
        else {
            this._disabledClass = '';
        }
    };
    /**
     * @private
     * @param {?} switchLabel
     * @param {?} value
     * @return {?}
     */
    NgxBootstrapSwitchComponent.prototype._setColor = /**
     * @private
     * @param {?} switchLabel
     * @param {?} value
     * @return {?}
     */
    function (switchLabel, value) {
        /** @type {?} */
        var color = '';
        /** @type {?} */
        var defaultColor = 'bootstrap-switch-info';
        if (switchLabel === 'off') {
            defaultColor = 'bootstrap-switch-default';
        }
        switch (value) {
            case 'default':
                color = defaultColor;
                break;
            case 'blue':
                color = 'bootstrap-switch-primary';
                break;
            case 'sky-blue':
                color = 'bootstrap-switch-info';
                break;
            case 'red':
                color = 'bootstrap-switch-danger';
                break;
            case 'yellow':
                color = 'bootstrap-switch-warning';
                break;
            case 'green':
                color = 'bootstrap-switch-success';
                break;
            case 'gray':
                color = 'bootstrap-switch-default';
                break;
        }
        if (switchLabel === 'off') {
            this._offColor = color;
        }
        else {
            this._onColor = color;
        }
    };
    /**
     * @private
     * @return {?}
     */
    NgxBootstrapSwitchComponent.prototype._calculateWidth = /**
     * @private
     * @return {?}
     */
    function () {
        if (this._onSpan) {
            this.renderer.setStyle(this._onSpan.nativeElement, 'width', '');
            this.renderer.setStyle(this._midSpan.nativeElement, 'width', '');
            this.renderer.setStyle(this._offSpan.nativeElement, 'width', '');
            this.renderer.setStyle(this._main.nativeElement, "width", "");
            /** @type {?} */
            var width = Math.max(this._onSpan.nativeElement.clientWidth, this._offSpan.nativeElement.clientWidth, this._minWidth);
            this.renderer.setStyle(this._onSpan.nativeElement, 'width', width.toString() + 'px');
            this.renderer.setStyle(this._midSpan.nativeElement, 'width', width.toString() + 'px');
            this.renderer.setStyle(this._offSpan.nativeElement, 'width', width.toString() + 'px');
            this.renderer.setStyle(this._container.nativeElement, 'width', (width * 3).toString() + 'px');
            this.renderer.setStyle(this._main.nativeElement, 'width', (width * 2).toString() + 'px');
        }
    };
    /**
     * @private
     * @return {?}
     */
    NgxBootstrapSwitchComponent.prototype._calculateSize = /**
     * @private
     * @return {?}
     */
    function () {
        switch (this.size) {
            case 'mini':
                this._sizeClass = 'bootstrap-switch-mini';
                this._minWidth = 25;
                break;
            case 'small':
                this._sizeClass = 'bootstrap-switch-small';
                this._minWidth = 30;
                break;
            case 'normal':
                this._sizeClass = 'bootstrap-switch-normal';
                this._minWidth = 60;
                break;
            case 'large':
                this._sizeClass = 'bootstrap-switch-large';
                this._minWidth = 80;
                break;
        }
        this._needCalculateWidth = true;
    };
    /**
     * @return {?}
     */
    NgxBootstrapSwitchComponent.prototype.ngAfterViewChecked = /**
     * @return {?}
     */
    function () {
        if (this._needCalculateWidth) {
            this._calculateWidth();
            this._needCalculateWidth = false;
        }
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    NgxBootstrapSwitchComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        for (var propName in changes) {
            if (changes.hasOwnProperty(propName)) {
                /** @type {?} */
                var changedProp = changes[propName];
                /** @type {?} */
                var from = changedProp.previousValue;
                /** @type {?} */
                var value = changedProp.currentValue;
                switch (propName) {
                    case 'onText':
                        this._needCalculateWidth = true;
                        break;
                    case 'offText':
                        this._needCalculateWidth = true;
                        break;
                    case 'onColor':
                        this._setColor('on', value);
                        break;
                    case 'offColor':
                        this._setColor('off', value);
                        break;
                    case 'status':
                        this._statusStr = value.toString();
                        break;
                    case 'size':
                        this._calculateSize();
                        break;
                    case 'disabled':
                        this._setDisabled(value);
                        break;
                }
            }
        }
    };
    NgxBootstrapSwitchComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-switch',
                    template: "<div #main class=\"bootstrap-switch bootstrap-switch-wrapper bootstrap-switch-animate bootstrap-switch-off\"\r\n    [ngClass]=\"_sizeClass + ' ' + _disabledClass\" (click)=\"toggleStatus()\">\r\n    <div #container class=\"bootstrap-switch-container\" [@statusChange]=\"_statusStr\">\r\n        <span #on class=\"bootstrap-switch-handle-on\" [ngClass]=\"_onColor\" [ngStyle]=\"{'min-width': _minWidth +'px'}\">{{ onText }}</span>\r\n        <span #mid class=\"bootstrap-switch-label\"></span>\r\n        <span #off class=\"bootstrap-switch-handle-off \" [ngClass]=\"_offColor\">{{ offText }}</span>\r\n    </div>\r\n</div>",
                    animations: [
                        trigger('statusChange', [
                            state('false', style({ transform: 'translateX(-33.333%)' })),
                            state('true', style({ transform: 'translateX(0)' })),
                            transition('true <=> false', animate('200ms'))
                        ])
                    ],
                    encapsulation: ViewEncapsulation.None,
                    styles: [".bootstrap-switch{display:inline-block;direction:ltr;cursor:pointer;border-radius:4px;border:1px solid #ccc;position:relative;text-align:left;overflow:hidden;line-height:8px;z-index:0;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;vertical-align:middle;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}.bootstrap-switch .bootstrap-switch-container{display:inline-block;top:0;border-radius:4px;-webkit-transform:translate3d(0,0,0);transform:translate3d(0,0,0);background:#fff}.bootstrap-switch .bootstrap-switch-handle-off,.bootstrap-switch .bootstrap-switch-handle-on,.bootstrap-switch .bootstrap-switch-label{box-sizing:border-box;cursor:pointer;display:inline-block!important;height:100%;padding:6px 12px;font-size:14px;line-height:20px}.bootstrap-switch .bootstrap-switch-handle-off,.bootstrap-switch .bootstrap-switch-handle-on{text-align:center;z-index:1;white-space:nowrap}.bootstrap-switch .bootstrap-switch-handle-off.bootstrap-switch-primary,.bootstrap-switch .bootstrap-switch-handle-on.bootstrap-switch-primary{color:#fff;background:#428bca}.bootstrap-switch .bootstrap-switch-handle-off.bootstrap-switch-info,.bootstrap-switch .bootstrap-switch-handle-on.bootstrap-switch-info{color:#fff;background:#5bc0de}.bootstrap-switch .bootstrap-switch-handle-off.bootstrap-switch-success,.bootstrap-switch .bootstrap-switch-handle-on.bootstrap-switch-success{color:#fff;background:#5cb85c}.bootstrap-switch .bootstrap-switch-handle-off.bootstrap-switch-warning,.bootstrap-switch .bootstrap-switch-handle-on.bootstrap-switch-warning{background:#f0ad4e;color:#fff}.bootstrap-switch .bootstrap-switch-handle-off.bootstrap-switch-danger,.bootstrap-switch .bootstrap-switch-handle-on.bootstrap-switch-danger{color:#fff;background:#d9534f}.bootstrap-switch .bootstrap-switch-handle-off.bootstrap-switch-default,.bootstrap-switch .bootstrap-switch-handle-on.bootstrap-switch-default{color:#000;background:#eee}.bootstrap-switch .bootstrap-switch-label{text-align:center;margin-top:-1px;margin-bottom:-1px;z-index:100;color:#333;background:#fff}.bootstrap-switch .bootstrap-switch-handle-on{border-bottom-left-radius:3px;border-top-left-radius:3px}.bootstrap-switch .bootstrap-switch-handle-off{border-bottom-right-radius:3px;border-top-right-radius:3px}.bootstrap-switch input[type=checkbox],.bootstrap-switch input[type=radio]{position:absolute!important;top:0;left:0;opacity:0;z-index:-1}.bootstrap-switch input[type=checkbox].form-control,.bootstrap-switch input[type=radio].form-control{height:auto}.bootstrap-switch.bootstrap-switch-mini .bootstrap-switch-handle-off,.bootstrap-switch.bootstrap-switch-mini .bootstrap-switch-handle-on,.bootstrap-switch.bootstrap-switch-mini .bootstrap-switch-label{padding:1px 5px;font-size:12px;line-height:1.5}.bootstrap-switch.bootstrap-switch-small .bootstrap-switch-handle-off,.bootstrap-switch.bootstrap-switch-small .bootstrap-switch-handle-on,.bootstrap-switch.bootstrap-switch-small .bootstrap-switch-label{padding:5px 10px;font-size:12px;line-height:1.5}.bootstrap-switch.bootstrap-switch-large .bootstrap-switch-handle-off,.bootstrap-switch.bootstrap-switch-large .bootstrap-switch-handle-on,.bootstrap-switch.bootstrap-switch-large .bootstrap-switch-label{padding:6px 16px;font-size:18px;line-height:1.33}.bootstrap-switch.bootstrap-switch-disabled,.bootstrap-switch.bootstrap-switch-indeterminate,.bootstrap-switch.bootstrap-switch-readonly{cursor:default!important}.bootstrap-switch.bootstrap-switch-disabled .bootstrap-switch-handle-off,.bootstrap-switch.bootstrap-switch-disabled .bootstrap-switch-handle-on,.bootstrap-switch.bootstrap-switch-disabled .bootstrap-switch-label,.bootstrap-switch.bootstrap-switch-indeterminate .bootstrap-switch-handle-off,.bootstrap-switch.bootstrap-switch-indeterminate .bootstrap-switch-handle-on,.bootstrap-switch.bootstrap-switch-indeterminate .bootstrap-switch-label,.bootstrap-switch.bootstrap-switch-readonly .bootstrap-switch-handle-off,.bootstrap-switch.bootstrap-switch-readonly .bootstrap-switch-handle-on,.bootstrap-switch.bootstrap-switch-readonly .bootstrap-switch-label{opacity:.5;cursor:default!important}.bootstrap-switch.bootstrap-switch-animate .bootstrap-switch-container{transition:margin-left .5s}.bootstrap-switch.bootstrap-switch-inverse .bootstrap-switch-handle-on{border-radius:0 3px 3px 0}.bootstrap-switch.bootstrap-switch-inverse .bootstrap-switch-handle-off{border-radius:3px 0 0 3px}.bootstrap-switch.bootstrap-switch-focused{border-color:#66afe9;outline:0;box-shadow:inset 0 1px 1px rgba(0,0,0,.075),0 0 8px rgba(102,175,233,.6)}.bootstrap-switch.bootstrap-switch-inverse.bootstrap-switch-off .bootstrap-switch-label,.bootstrap-switch.bootstrap-switch-on .bootstrap-switch-label{border-bottom-right-radius:3px;border-top-right-radius:3px}.bootstrap-switch.bootstrap-switch-inverse.bootstrap-switch-on .bootstrap-switch-label,.bootstrap-switch.bootstrap-switch-off .bootstrap-switch-label{border-bottom-left-radius:3px;border-top-left-radius:3px}"]
                }] }
    ];
    /** @nocollapse */
    NgxBootstrapSwitchComponent.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Renderer2 }
    ]; };
    NgxBootstrapSwitchComponent.propDecorators = {
        _onSpan: [{ type: ViewChild, args: ['on',] }],
        _offSpan: [{ type: ViewChild, args: ['off',] }],
        _midSpan: [{ type: ViewChild, args: ['mid',] }],
        _container: [{ type: ViewChild, args: ['container',] }],
        _main: [{ type: ViewChild, args: ['main',] }],
        status: [{ type: Input }],
        statusChange: [{ type: Output }],
        onText: [{ type: Input }],
        offText: [{ type: Input }],
        onColor: [{ type: Input }],
        offColor: [{ type: Input }],
        size: [{ type: Input }],
        disabled: [{ type: Input }]
    };
    return NgxBootstrapSwitchComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapSwitchModule = /** @class */ (function () {
    function NgxBootstrapSwitchModule() {
    }
    /**
     * @return {?}
     */
    NgxBootstrapSwitchModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: NgxBootstrapSwitchModule,
            providers: []
        };
    };
    NgxBootstrapSwitchModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: [
                        NgxBootstrapSwitchComponent
                    ],
                    exports: [
                        NgxBootstrapSwitchComponent
                    ]
                },] }
    ];
    return NgxBootstrapSwitchModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxBootstrapSwitchModule, NgxBootstrapSwitchComponent };

//# sourceMappingURL=ngx-bootstrap-switch.js.map